(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
"use strict";
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Jan Dolejsi. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
Object.defineProperty(exports, "__esModule", { value: true });
exports.getElementByIdOrThrow = exports.applyThemeToNetwork = exports.setIsInset = exports.addWindowEventListener = exports.expandInset = exports.closeInset = void 0;
// let vscode: VsCodeApi | undefined;
// try {
//     vscode = acquireVsCodeApi();
// } catch (error) {
//     console.warn(error);
//     // swallow, so the script can be tested in a browser
// }
function closeInset() {
    postCommand('close');
}
exports.closeInset = closeInset;
function expandInset() {
    postCommand('expand');
}
exports.expandInset = expandInset;
function addWindowEventListener(messageHandler) {
    window.addEventListener('message', event => {
        const message = event.data;
        console.log("Received message: " + message.command);
        switch (message.command) {
            case 'setIsInset':
                setIsInset(message.value);
                break;
            default:
                messageHandler(message);
        }
    });
}
exports.addWindowEventListener = addWindowEventListener;
/**
 * Sets whether this is an inset or a document content
 * @param {boolean} isInset true if this view is an inset
 */
function setIsInset(isInset) {
    const insetMenu = document.getElementById('insetMenu');
    if (insetMenu) {
        insetMenu.style.display = isInset ? 'initial' : 'none';
    }
    const separators = document.getElementsByClassName('separator');
    for (let index = 0; index < separators.length; index++) {
        const separator = separators[index];
        separator.style.display = isInset ? 'initial' : 'none';
    }
    // apply style to the body
    document.body.style.overflow = isInset ? 'scroll' : '';
    document.body.style.margin = document.body.style.padding = "0px";
}
exports.setIsInset = setIsInset;
/**
 * Applies theme to a network object
 * @param network network visualization object
 * @param newTheme new theme applied
 */
function applyThemeToNetwork(network, newTheme) {
    let foreground;
    let background;
    switch (newTheme) {
        case 'dark':
            foreground = 'white';
            background = 'black';
            break;
        case 'light':
            foreground = 'black';
            background = 'white';
            break;
    }
    network.setOptions({ edges: { font: { color: foreground, strokeColor: background } } });
}
exports.applyThemeToNetwork = applyThemeToNetwork;
function getElementByIdOrThrow(elementId) {
    const el = document.getElementById(elementId);
    if (!el) {
        throw new Error(`HTML document does not contain element with ID=${elementId}`);
    }
    return el;
}
exports.getElementByIdOrThrow = getElementByIdOrThrow;

},{}],2:[function(require,module,exports){
"use strict";
/* --------------------------------------------------------------------------------------------
 * Copyright (c) Jan Dolejsi. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 * ------------------------------------------------------------------------------------------ */
"strict mode";
Object.defineProperty(exports, "__esModule", { value: true });
const baseView_1 = require("./baseView");
const nodes = new vis.DataSet([]);
const edges = new vis.DataSet([]);
const networkData = {
    nodes: nodes,
    edges: edges
};
let network;
let _inverted = false;
const TOP_DOWN = "TOP_DOWN";
const LEFT_RIGHT = "LEFT_RIGHT";
let _layout = TOP_DOWN;
let _settings = false;
let _origData = {
    nodes: [],
    relationships: []
};
// eslint-disable-next-line @typescript-eslint/no-unused-vars
function initialize() {
    // create a network
    const container = baseView_1.getElementByIdOrThrow("network");
    const options = {
        autoResize: true,
        height: '100%',
        width: '100%',
        nodes: {
            font: {
                size: 12
            }
        },
        edges: {
            arrows: {
                to: {
                    enabled: true,
                    scaleFactor: 0.5
                }
            },
            font: {
                size: 8,
                align: "top"
            },
            smooth: false
        },
        layout: {
            hierarchical: {
                enabled: true,
                direction: "DU",
                sortMethod: "directed"
            }
        },
        physics: {
            enabled: false,
            minVelocity: 0.75,
            solver: "hierarchicalRepulsion"
        },
        configure: false
    };
    network = new vis.Network(container, networkData, options);
    resize();
    network.on("configChange", function () {
        // this will immediately fix the height of the configuration
        // wrapper to prevent unecessary scrolls in chrome.
        // see https://github.com/almende/vis/issues/1568
        const div = container.getElementsByClassName("vis-configuration-wrapper")[0];
        div.style["height"] = div.getBoundingClientRect().height + "px";
    });
    document.body.addEventListener("themeChanged", (event) => {
        network && baseView_1.applyThemeToNetwork(network, event.detail.newTheme);
    });
    if (!baseView_1.vscode) {
        populateWithTestData();
    }
    ensureLayout();
    onLoad();
}
function handleMessage(message) {
    switch (message.command) {
        case 'updateContent':
            updateGraph(message.data);
            break;
        case 'setInverted':
            setInverted(message.value);
            break;
        case 'setOptions':
            setOptions(message.options);
            break;
        default:
            console.log("Unexpected message: " + message.command);
    }
}
baseView_1.addWindowEventListener(handleMessage);
function populateWithTestData() {
    // for testing only
    updateGraph({
        nodes: [{ id: 1, label: 'City' }, { id: 2, label: 'Town nnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn' }, { id: 3, label: 'Village' }, { id: 4, label: 'Capital' }],
        relationships: [{ from: 1, to: 2 }, { from: 2, to: 3 }, { from: 4, to: 2 }]
    });
    baseView_1.setIsInset(true);
}
function clearNetwork() {
    nodes.clear();
    edges.clear();
}
function updateGraph(data) {
    _origData = data;
    clearNetwork();
    if (data.nodes) {
        nodes.add(data.nodes);
    }
    edges.add(data.relationships);
    network === null || network === void 0 ? void 0 : network.fit({ animation: true });
}
function resize() {
    const container = baseView_1.getElementByIdOrThrow("network");
    const visNetwork = container.getElementsByClassName("vis-network")[0];
    const canvas = visNetwork.canvas;
    if (canvas) {
        network === null || network === void 0 ? void 0 : network.setSize(canvas.style["width"], (window.innerHeight - 6) + "px");
    }
}
/**
 * Sets the `inverted` fag.
 * @param inverted should the direction of the graph layout be inverted?
 */
function setInverted(inverted) {
    _inverted = inverted;
    ensureLayout();
}
function ensureLayout() {
    if (_layout === TOP_DOWN) {
        topDown();
    }
    else if (_layout === LEFT_RIGHT) {
        leftRight();
    }
}
function topDown() {
    _layout = TOP_DOWN;
    setLayoutDirection(_inverted ? 'DU' : 'UD');
}
function leftRight() {
    _layout = LEFT_RIGHT;
    setLayoutDirection(_inverted ? 'RL' : 'LR');
}
function setLayoutDirection(direction) {
    network === null || network === void 0 ? void 0 : network.setOptions({ layout: { hierarchical: { direction: direction } } });
}
function setOptions(options) {
    network === null || network === void 0 ? void 0 : network.setOptions(options);
}
function fit() {
    network === null || network === void 0 ? void 0 : network.fit();
}
function toggleSettings() {
    _settings = !_settings;
    network === null || network === void 0 ? void 0 : network.setOptions({ configure: _settings });
    document.body.style.overflow = _settings ? 'scroll' : 'hidden';
    if (_settings) {
        const settingsElement = document.getElementsByClassName("vis-configuration-wrapper")[0];
        if (settingsElement) {
            settingsElement.scrollIntoView();
        }
    }
}
function reset() {
    updateGraph(_origData);
}
// subscribe to view events
document.body.onload = initialize;
document.body.onresize = resize;
baseView_1.getElementByIdOrThrow("reset").onclick = reset;
baseView_1.getElementByIdOrThrow("toggleSettings").onclick = toggleSettings;
baseView_1.getElementByIdOrThrow("fit").onclick = fit;
baseView_1.getElementByIdOrThrow("topDown-light").onclick = topDown;
baseView_1.getElementByIdOrThrow("topDown-dark").onclick = topDown;
baseView_1.getElementByIdOrThrow("leftRight-light").onclick = leftRight;
baseView_1.getElementByIdOrThrow("leftRight-dark").onclick = leftRight;
baseView_1.getElementByIdOrThrow("expandInset").onclick = baseView_1.expandInset;
baseView_1.getElementByIdOrThrow("closeInset").onclick = baseView_1.closeInset;

},{"./baseView":1}]},{},[2]);
